#include "LIB_LCD.h"



const byte ascii[] = {
/* */ 0x00,0x00,
/*!*/ 0x00,0x00,
/*"*/ 0x00,0x00,
/*#*/ 0x00,0x00,
/*$*/ 0x00,0x00,
/*%*/ 0x00,0x00,
/*&*/ 0x00,0x00,
/*'*/ 0x00,0x00,
/*(*/ 0x00,0x00,
/*)*/ 0x00,0x00,
/***/ 0x84,0x45,
/*+*/ 0x48,0x01,
/*,*/ 0x00,0x00,
/*-*/ 0x00,0x01,
/*.*/ 0x00,0x00,
/* */ 0x00,0x00,
/*0*/ 0x23,0x8A,
/*1*/ 0x03,0x00,
/*2*/ 0x22,0x89,
/*3*/ 0x23,0x09,
/*4*/ 0x03,0x03,
/*5*/ 0x21,0x0B,
/*6*/ 0x21,0x8B,
/*7*/ 0x03,0x08,
/*8*/ 0x23,0x8B,
/*9*/ 0x23,0x0B,
/*:*/ 0x00,0x00,
/*;*/ 0x00,0x00,
/*<*/ 0x00,0x00,
/*=*/ 0x00,0x00,
/*>*/ 0x00,0x00,
/*?*/ 0x00,0x00,
/*@*/ 0x00,0x00,
/*A*/ 0x03,0x8B,
/*B*/ 0x6B,0x09,
/*C*/ 0x20,0x8A,
/*D*/ 0x6B,0x08,
/*E*/ 0x20,0x8B,
/*F*/ 0x00,0x8B,
/*G*/ 0x21,0x8B,
/*H*/ 0x03,0x83,
/*I*/ 0x03,0x00,
/*J*/ 0x23,0x00,
/*K*/ 0xCC,0x00,
/*L*/ 0x20,0x82,
/*M*/ 0x07,0x86,
/*N*/ 0x83,0x86,
/*O*/ 0x23,0x8A,
/*P*/ 0x02,0x8B,
/*Q*/ 0xA3,0x8A,
/*R*/ 0x82,0x8B,
/*S*/ 0x21,0x0B,
/*T*/ 0x48,0x08,
/*U*/ 0x23,0x82,
/*V*/ 0x04,0xC2,
/*W*/ 0x83,0xC2,
/*X*/ 0x84,0x44,
/*Y*/ 0x44,0x04,
/*Z*/ 0x24,0x48,
/*[*/ 0x00,0x00,
/*\*/ 0x80,0x04,
/*]*/ 0x00,0x00,
/*^*/ 0x00,0x00,
/*_*/ 0x20,0x00,
};

const byte GD5221P_8[22] = {0x01, 0x02, 0x04, 0x08,
                      0x00, 0x00, 0x00, 0x00,
                      0x00, 0x00, 0x00, 0x00,
                      0x00, 0x00, 0x00, 0x00,
                      0x00, 0x00, 0x10, 0x20,
                      0x40, 0x80};
                      
byte Display_Buf[14] = {0x00, 0x00, 0x00, 0x00,
                        0x00, 0x00, 0x00, 0x00,
                        0x00, 0x00, 0x00, 0x00,
                        0x00, 0x00};

                      
void LCD_WF_init(void){

  byte i;
  byte *p = (char *)0x20;
  
  for (i = 0; i < 22; i++) {
    *p++ = GD5221P_8[i];
  }
}

void LCD_pos(byte pos, byte display){
  byte c;
  c = (display - 0x20) << 1;
  
  if (pos == 1){
    LCDWF15 = ascii[c];
    LCDWF5  = ascii[c + 1]; 
  } else if (pos == 2) {
    LCDWF14 = ascii[c];
    LCDWF6  = ascii[c + 1]; 
  } else if (pos == 3) {
    LCDWF4  = ascii[c];
    LCDWF7  = ascii[c + 1]; 
  } else if (pos == 4) {
    LCDWF17 = ascii[c];
    LCDWF8  = ascii[c + 1]; 
  } else if (pos == 5) {
    LCDWF16 = ascii[c];
    LCDWF9  = ascii[c + 1]; 
  } else if (pos == 6) {
    LCDWF13 = ascii[c];
    LCDWF10 = ascii[c + 1]; 
  }
}

void LCD_pos_buf(byte pos, byte display){
  byte c;
  c = (display - 0x20) << 1;
  
  if (pos == 1){
    Display_Buf[11] = ascii[c];
    Display_Buf[1]  = ascii[c + 1]; 
  } else if (pos == 2) {
    Display_Buf[10] = ascii[c];
    Display_Buf[2]  = ascii[c + 1]; 
  } else if (pos == 3) {
    Display_Buf[0]  = ascii[c];
    Display_Buf[3]  = ascii[c + 1]; 
  } else if (pos == 4) {
    Display_Buf[13] = ascii[c];
    Display_Buf[4]  = ascii[c + 1]; 
  } else if (pos == 5) {
    Display_Buf[12] = ascii[c];
    Display_Buf[5]  = ascii[c + 1]; 
  } else if (pos == 6) {
    Display_Buf[9] = ascii[c];
    Display_Buf[6] = ascii[c + 1]; 
  }
}

void LCD_Buf_WF(void){

  byte i;
  byte *p = (char *)0x24;
  
  for (i = 0; i < 14; i++) {
    *p++ = Display_Buf[i];
  }
}